AchievementNudist = class(Turbine.UI.Control)
function AchievementNudist:Constructor(handler)
    Turbine.UI.Control.Constructor(self)

    self.allowedIndices = {
        [Turbine.Gameplay.Equipment.PrimaryWeapon] = true,
        [Turbine.Gameplay.Equipment.SecondaryWeapon] = true,
        [Turbine.Gameplay.Equipment.Class] = true,
        [Turbine.Gameplay.Equipment.CraftTool] = true,
        [Turbine.Gameplay.Equipment.RangedWeapon] = true,
        [Turbine.Gameplay.Equipment.Instrument] = true,
    }

    self.equipment = Turbine.Gameplay.LocalPlayer.GetInstance():GetEquipment()

    for i = 1, self.equipment:GetSize() do
        if not self.allowedIndices[i] and self.equipment:GetItem(i) then
            handler:Fail("Nudist", "Equipped a wrong item", 0x410081B3)
        end
    end
    self.timer = 0
    self.itemIndex = 0
    self.itemEquippedCallback = AddCallback(self.equipment, "ItemEquipped", function(sender, args)
        if not self.allowedIndices[args.Index] then
            if not( self.updateCallback) then
                self.itemIndex = args.Index
                self.timer = 10
                self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate)
                ChatOutput("<rgb=#FF0000>Unequip your item within 10 seconds or you will fail the achievement!")
            end
        end
    end)

    self.itemUnEquippedCallback= AddCallback(self.equipment, "ItemUnequipped", function(sender, args)
        if self.updateCallback and self.itemIndex == args.Index then
            ChatOutput("<rgb=#00FF00>Item successfully unequipped.")
            RemoveCallback(Updater, "ExecuteUpdate",  self.updateCallback)
            self.updateCallback = nil
        end
    end)

    self.ExecuteUpdate = function(delta)
        self.timer = self.timer - delta
        if self.timer < 0 then
            handler:Fail("Nudist", "Equipped a wrong item", 0x410081B3)
            if self.updateCallback then
                RemoveCallback(Updater, "ExecuteUpdate",  self.updateCallback)
                self.updateCallback = nil
            end
        end

    end

end

function AchievementTheWhiteKnight:Unload()
    if self.updateCallback then
        RemoveCallback(Updater, "ExecuteUpdate",  self.updateCallback)
        self.updateCallback = nil
    end
    RemoveCallback(self.equipment, "ItemEquipped", self.itemEquippedCallback)
    RemoveCallback(self.equipment, "ItemUnequipped", self.itemUnEquippedCallback)
end